unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ComCtrls, SyncObjs, ExtCtrls;

type
  TDemoThread = class( TThread )
  protected
    procedure Execute(); override;

  end;

  TForm1 = class(TForm)
    StartButton: TButton;
    ProgressBar1: TProgressBar;
    StopButton: TButton;
    Timer1: TTimer;
    procedure StartButtonClick(Sender: TObject);
    procedure StopButtonClick(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    FThread   : TDemoThread;
    FProgress : Integer;

  private
    procedure DoTerminate(Sender: TObject);

  public
    procedure UpdateProgress( AProgress : Integer );

  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.StartButtonClick(Sender: TObject);
begin
  StartButton.Enabled := False;
  StopButton.Enabled := True;

  FThread := TDemoThread.Create( True );
  FThread.FreeOnTerminate := True;
  FThread.OnTerminate := DoTerminate;
  FThread.Resume();

end;

procedure TForm1.DoTerminate(Sender: TObject);
begin
  FThread := NIL;
  StopButton.Enabled := False;
  StartButton.Enabled := True;
end;

procedure TForm1.StopButtonClick(Sender: TObject);
begin
  if( FThread <> NIL ) then
    FThread.Terminate();

end;

procedure TForm1.UpdateProgress( AProgress : Integer );
begin
  InterlockedExchange( FProgress, AProgress );
end;

procedure TDemoThread.Execute();
var
  I : Integer;
  J : Integer;
  F : TextFile;
  S : String;


begin
  for J := 0 to 100 do
    begin
    if( Terminated ) then
      Break;

    AssignFile( F, 'Data.txt' );
    Reset( F );

    for I := 0 to 1000000 do
      Readln(F, S );

    CloseFile(F);
    Form1.UpdateProgress( J );
    end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  ProgressBar1.Position := InterlockedExchangeAdd( FProgress, 0 );
end;

end.
